from tkinter import *
import math,time
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
NUM=200; Cells=array(2, NUM+2);NUMH=int(NUM/2+1)
dh=0.1;dh2=dh*dh #dh: 空間刻み幅
dt=0.01          #dt: 時間刻み幅
ii=NUMH; k1=int(NUM/8)-10
#Cells[0][ii]=1                #設定パターン1
#for i in range(-k1,k1+1):     #設定パターン2
#    Cells[0][ii+i]=math.sin(i*math.pi/18)
#for i in range(-k1,k1+1):     #設定パターン3
#    Cells[0][ii+i]=math.cos(i*math.pi/18)
#for i in range(-k1,k1+1):     #設定パターン4
#    Cells[0][ii+i]=(i % 10)/10
#for i in range(-10,11):       #設定パターン5
#    Cells[0][ii+i]=1
for i in range(-10,11):       #設定パターン6
    if   i==0: Cells[0][ii+i]=0
    elif i< 0: Cells[0][ii+i]=-1
    else     : Cells[0][ii+i]=1
#for i in range(1,NUM+1):     #設定パターン7
#    V=0
#    if i<ii-10: V=-1
#    if i>ii+10: V=1
#    Cells[0][i]=V
#for i in range(1,NUM+1):     #設定パターン8
#    V=0
#    if i<ii-10: V=1
#    if i>=ii+10: V=-1
#    Cells[0][i]=V

def R(u): return u*(u-1)
def Du(i1,i):
    D=0.5 #拡散係数
    global Cells,dh2; i2=1-i1
    u=Cells[i1][i];up=Cells[i1][i+1];um=Cells[i1][i-1]
    return D*(up-2*u+um)/dh2+R(u)
def compCells(i1):#セルの値計算
    global Cells,dt; i2=1-i1
    for i in range(1,NUM+1):
        Cells[i2][i]=Cells[i1][i]+Du(i1,i)*dt
    return i2
def drawState(canvas,i1,t):#現状態の表示
    global Cells,NUM;DX=2;DY=100;X0=20;Y0=200
    canvas.delete("DT")
    X1=X0+NUM*DX/2; Y1=40; stTX="%5.2f" % t
    canvas.create_text(X1,Y1,text=stTX,tag="DT")
    for i in range(1,NUM+1):
        X1=(i-1)*DX+X0;X2=i*DX+X0
        Y1=-Cells[i1][i-1]*DY+Y0
        Y2=-Cells[i1][i  ]*DY+Y0
        canvas.create_line(X1,Y1,X2,Y2,fill="green",tag="DT",width=2)
def leftMouseDown(event):#マウス左ボタンクリック
    global root,canvas,i1,t,dt,exeflag
    exeflag=False;i1=compCells(i1);t+=dt
    drawState(canvas,i1,t);root.update()
def initDraw(canvas):#初期表示
    global NUM
    DX=2;DY=100;X0=20;Y0=200;X2=NUM*DX+X0;NUMH=int(NUM/2+1)
    #for i in range(-15,16):#格子を表示したいときは注釈を外す。
    #    Y2=-i*10+Y0; CL="gray"
    #    if i==0:CL="black"
    #    canvas.create_line(X0,Y2,X2,Y2,fill=CL,width=1)
    #for i in range(1,NUM+2,5):
    #    X1=(i-1)*DX+X0; CL="gray"
    #    if i==NUMH:CL="black"
    #    canvas.create_line(X1,Y0+150,X1,50,fill=CL,width=1)
    canvas.create_rectangle(X0,Y0-150,X2,Y0+150,
                            width=2,outline="gray")

#メイン・プログラム
root=Tk();root.title("Continuous spatial automata")
canvas=Canvas(root,width=640,height=400,bg="white")
canvas.pack();root.update()
canvas.bind("<Button-1>",leftMouseDown)
initDraw(canvas)
t=0;i1=0; drawState(canvas,i1,t)
root.update()
exeflag=True
while exeflag:
    i1=compCells(i1);t+=dt
    drawState(canvas,i1,t)
    root.update()
    time.sleep(0.01)
mainloop()
